<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00004000PeriodoVigenciaContratoFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * A função "alteraVigenciaContrato" altera os dados de vigência do contrato
     */
    
    public function alteraVigenciaContrato($params){
        
        $queryAlteraVigenciaContr = "UPDATE FCT_CONTRATO
                                     SET DTINIVIGENCONT = :DTINIVIGENCONT,
                                         DTFINVIGENCONT = :DTFINVIGENCONT,
                                         NRDIASPRORGCONT = TO_DATE(:DTFINVIGENCONT)-TO_DATE(:DTINIVIGENCONT)+1
                                   WHERE NRSEQCONTRATO = :NRSEQCONTRATO
                                     AND NRORG = :NRORG";

        $std = $this->connection->prepare($queryAlteraVigenciaContr);
        $std->execute($params);
    }
    
     /**
     * A função "validaDadosProrrog" valida se ja existem alterações de vigência para o contrato
     */
    
    public function validaDadosProrrog($params){
        
        $queryValidaDadosProrrog = "SELECT MAX(NRSEQPRORRCONT) AS NRSEQPRORRCONT
                                      FROM FCT_PRORROGCONTRATO
                                     WHERE NRSEQCONTRATO = :NRSEQCONTRATO
                                       AND NRORG = :NRORG";

        $std = $this->connection->prepare($queryValidaDadosProrrog);
        $std->execute($params);
        $returnValidaDadosProrrog = $std->fetchAll();
        return $returnValidaDadosProrrog;
    }
    
    /**
     * A função "alteraDadosProrrog" inativa as alterações de vigência do contrato
     */
    
    public function alteraDadosProrrog($params){
        
        $queryAlteraDadosProrrog = "UPDATE FCT_PRORROGCONTRATO
                                       SET IDDTATIVO = 'N'
                                     WHERE NRSEQCONTRATO = :NRSEQCONTRATO
                                       AND NRSEQPRORRCONT <> :NRSEQPRORRCONT
                                       AND NRORG = :NRORG";

        $std = $this->connection->prepare($queryAlteraDadosProrrog);
        $std->execute($params);
    }
}
?>